@ vim:filetype=armasm


.extern colorAlp
.extern buf
.extern l1buf
.extern l2buf

.extern pbuf
.extern smokeBuf


.global blendScreen
blendScreen:
    stmfd   sp!, {r4-r9,lr}
    ldr     r0, =buf
    ldr     r1, =l1buf
    ldr     r2, =l2buf
    ldr     r3, =colorAlp
    ldr     r0, [r0]

    mov     lr, #0xff
    mov     r12,#(160*240/4)

bs_loop:
    ldr     r4, [r1], #4
    ldr     r5, [r2], #4

    and     r6, lr, r4
    and     r7, lr, r5
    orr     r7, r7, r6, lsl #8
    ldrb    r8, [r3, r7]
    and     r6, lr, r4, lsr #8
    and     r7, lr, r5, lsr #8
    orr     r7, r7, r6, lsl #8
    ldrb    r9, [r3, r7]
    and     r6, lr, r4, lsr #16
    and     r7, lr, r5, lsr #16
    orr     r7, r7, r6, lsl #8
    orr     r9, r8, r9, lsl #8
    ldrb    r8, [r3, r7]
    and     r6, lr, r4, lsr #24
    and     r7, lr, r5, lsr #24
    orr     r7, r7, r6, lsl #8
    orr     r9, r9, r8, lsl #16
    ldrb    r8, [r3, r7]
    subs    r12,r12,#1
    orr     r9, r9, r8, lsl #24
    str     r9, [r0], #4
    bne     bs_loop

    ldmfd   sp!, {r4-r9,lr}
    bx      lr



.macro colorDfs
    tst     r2, #0x0000000f
    biceq   r2, r2, #0x000000ff
    subne   r2, r2, #0x00000001
    tst     r2, #0x00000f00
    biceq   r2, r2, #0x0000ff00
    subne   r2, r2, #0x00000100
    tst     r2, #0x000f0000
    biceq   r2, r2, #0x00ff0000
    subne   r2, r2, #0x00010000
    tst     r2, #0x0f000000
    biceq   r2, r2, #0xff000000
    subne   r2, r2, #0x01000000
.endm

.global smokeScreen
smokeScreen:
    stmfd   sp!, {r4,r5}
    ldr     r0, =pbuf
    ldr     r1, =l2buf

    @ memcpy(pbuf, l2buf, lyrSize);
    mov     r12,#(160*240/16)

ssc_loop1:
    ldmia   r1!, {r2-r5}
    subs    r12,r12,#1
    stmia   r0!, {r2-r5}
    bne     ssc_loop1

    @ l1buf[i] = colorDfs[l1buf[i]];
    ldr     r0, =l1buf
    mov     r12,#(160*240/4)

ssc_loop2:
    ldr     r2, [r0]
    colorDfs
    subs    r12,r12,#1
    str     r2, [r0], #4
    bne     ssc_loop2

    @ l2buf[i] = colorDfs[*(smokeBuf[i])];
    ldr     r1, =smokeBuf
    ldr     r0, =l2buf
    mov     r12,#(160*240/4)

ssc_loop3:
    ldr     r2, [r1], #4
    ldr     r3, [r1], #4
    ldrb    r2, [r2]
    ldr     r4, [r1], #4
    ldrb    r3, [r3]
    ldr     r5, [r1], #4
    ldrb    r4, [r4]
    ldrb    r5, [r5]
    orr     r2, r2, r3, lsl #8
    orr     r2, r2, r4, lsl #16
    orr     r2, r2, r5, lsl #24
    colorDfs
    subs    r12,r12,#1
    str     r2, [r0], #4
    bne     ssc_loop3

    ldmfd   sp!, {r4,r5}
    bx      lr



.global spend_cycles @ c

spend_cycles:
    mov     r0, r0, lsr #2  @ 4 cycles/iteration
    sub     r0, r0, #2      @ entry/exit/init
.sc_loop:
    subs    r0, r0, #1
    bpl     .sc_loop

    bx      lr


.global mmu_flushcache

mmu_flushcache:
    mov r2, #0
    swi #0x9f0002
    mov pc, lr

